<div class="panel">
  <div class="panel-title" [ngClass]="primaryColorBrand" [hidden]="isHideField">
    <span><mat-icon class="white-fg">directions_car</mat-icon></span>
    <span class="white-fg">&nbsp;Veículo</span>
    <div fxLayout="row" fxFlex="1 0 auto" fxLayoutGap="10px">
      <div fxFlex="70"></div>
      <div fxFlex="30" fxLayoutAlign="end end">

        <button mat-button class="px-16" [matMenuTriggerFor]="osMenu"
          fxLayoutAlign="end end">
          Ações&nbsp;&nbsp;
          <mat-icon>arrow_drop_down</mat-icon>
        </button>

        <mat-menu #osMenu="matMenu">

          <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item
            (click)="addVehicleNotFound()">
            <span>Adicionar veículo não encontrado</span>
          </button>
        </mat-menu>

      </div>
    </div>
  </div>
  <div class="panel-content">
    <form [formGroup]="vehicleForm">
      <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
        <mat-form-field fxFlex="25">
          <mat-select placeholder="Tipo do Veículo" formControlName="type"
            (selectionChange)="changeManufacture($event.value,null)" required>
            <mat-option *ngFor="let type of typeVehicleList"
              [value]="type['id']">
              {{type['name']}}
            </mat-option>
          </mat-select>

          <mat-error *ngIf="vehicleForm.get('type').hasError('required')">
            Por favor, selecione o tipo do veículo.
          </mat-error>
        </mat-form-field>

        <mat-form-field fxFlex="25">
          <mat-select placeholder="Marca" formControlName="manufacture"
            (selectionChange)="changeModel($event.value,null)" required
            *ngIf="(vehicleForm.value.type !== 'TRAILER' &&
            vehicleForm.value.type !== 'BOAT' && !isVehicleNotFound)">
            <mat-option *ngFor="let manufacture of manufactureList"
              [value]="manufacture['id']">
              {{manufacture['name']}}
            </mat-option>
          </mat-select>

          <input matInput placeholder="Marca" formControlName="manufacture"
            required *ngIf="vehicleForm.value.type === 'TRAILER' ||
            vehicleForm.value.type === 'BOAT' || isVehicleNotFound">
        </mat-form-field>

        <mat-form-field fxFlex="50">

          <input type="text" placeholder="Modelo" matInput
            formControlName="model" [formControl]="modelControl"
            [matAutocomplete]="auto" *ngIf="(vehicleForm.value.type != 'TRAILER'
            && vehicleForm.value.type !== 'BOAT' && !isVehicleNotFound)">
          <mat-autocomplete autoActiveFirstOption #auto="matAutocomplete"
            (optionSelected)='changeYears($event.option.value,null)'>
            <mat-option *ngFor="let model of filteredOptions | async"
              [value]="model['name']">
              {{model['name']}}
            </mat-option>
          </mat-autocomplete>

          <input matInput placeholder="Modelo" formControlName="model" required
            *ngIf="vehicleForm.value.type === 'TRAILER' ||
            vehicleForm.value.type
            === 'BOAT' || isVehicleNotFound">

        </mat-form-field>
      </div>

      <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
        <mat-form-field fxFlex="33">
          <mat-select placeholder="Ano do modelo" formControlName="modelYear"
            (selectionChange)="changeVehicle($event.value,null)" required
            *ngIf="(vehicleForm.value.type !== 'TRAILER' &&
            vehicleForm.value.type !== 'BOAT' && !isVehicleNotFound)">
            <mat-option *ngFor="let model of yearsList"
              [value]="model['idModeloAno']">
              {{model['name']}}
            </mat-option>
          </mat-select>
          <input matInput placeholder="Ano do modelo"
            formControlName="modelYear" required *ngIf="vehicleForm.value.type
            === 'TRAILER' || vehicleForm.value.type === 'BOAT' ||
            isVehicleNotFound">
        </mat-form-field>

        <mat-form-field fxFlex="34">
          <mat-select placeholder="Ano de fabricação"
            formControlName="registrationYear" required
            *ngIf="(vehicleForm.value.type != 'TRAILER' &&
            vehicleForm.value.type != 'BOAT' && !isVehicleNotFound)">
            <mat-option *ngFor="let year of registrationYearList"
              [value]="year">
              {{year}}
            </mat-option>
          </mat-select>
          <input matInput placeholder="Ano de fabricação"
            formControlName="registrationYear" required
            *ngIf="vehicleForm.value.type === 'TRAILER' ||
            vehicleForm.value.type
            === 'BOAT' || isVehicleNotFound">
        </mat-form-field>

        <mat-form-field fxFlex="33">

          <mat-select placeholder="Cor" formControlName="color" required>
            <mat-option *ngFor="let color of colorVehicleList" [value]="color">
              {{color}}
            </mat-option>
          </mat-select>
          <mat-error *ngIf="vehicleForm.get('type').hasError('required')">
            Por favor, selecione a cor do veículo.
          </mat-error>
        </mat-form-field>
      </div>


      <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
        <mat-form-field fxFlex="50">
          <input matInput placeholder="Placa" minlength="7"
            formControlName="licensePlate" [textMask]="{mask: licensePlateMask}"
            required>
          <mat-error
            *ngIf="vehicleForm.get('licensePlate').hasError('required')">
            Por favor, insira o número da placa.
          </mat-error>
          <mat-error
            *ngIf="vehicleForm.get('licensePlate').hasError('validNumberLicensePlate')">
            Por favor, informe uma placa válido
          </mat-error>
        </mat-form-field>

        <mat-form-field fxFlex="50">
          <input #input maxlength="17" matInput placeholder="Chassi"
            formControlName="chassi" maxlength="17" required>
          <mat-hint position="end">{{input.value?.length || 0}}/17</mat-hint>
          <mat-error *ngIf="vehicleForm.get('chassi').hasError('required')">
            Por favor, insira o número do chassi.
          </mat-error>
          <mat-error
            *ngIf="vehicleForm.get('chassi').hasError('validNumberChassi')">
            Por favor, informe um chassi válido
          </mat-error>
        </mat-form-field>

      </div>
    </form>
  </div>
</div>
